package com.jiuqi.grid;

import com.jiuqi.util.MemStream;
import com.jiuqi.util.StreamException;
import com.jiuqi.util.Stream;

public class PrintOptions
{
    private int zoom;
    private int mode;
    private int pageRows;
    private int pageCols;
    private int orientation;
    private static final byte BIFF_Print_Zoom = 10;
    private static final byte BIFF_Print_Mode = 11;
    private static final byte BIFF_Print_PageRows = 12;
    private static final byte BIFF_Print_PageCols = 13;
    private static final byte BIFF_Print_Orientation = 14;
    public static final int PAGE_DEFAULT = 0;
    public static final int PAGE_PORTRAIT = 1;
    public static final int PAGE_LANDSCAPE = 2;
    
    public PrintOptions() {
        this.zoom = -1;
        this.mode = -1;
        this.pageRows = -1;
        this.pageCols = -1;
        this.orientation = -1;
    }
    
    public int getOrientation() {
        return this.orientation;
    }
    
    public void setOrientation(final int value) {
        this.orientation = value;
    }
    
    public int getZoom() {
        return this.zoom;
    }
    
    public void setZoom(final int value) {
        this.zoom = value;
    }
    
    public int getMode() {
        return this.mode;
    }
    
    public void setMode(final int value) {
        this.mode = value;
    }
    
    public int getPageRows() {
        return this.pageRows;
    }
    
    public void setPageRows(final int value) {
        this.pageRows = value;
    }
    
    public int getPageCols() {
        return this.pageCols;
    }
    
    public void setPageCols(final int value) {
        this.pageCols = value;
    }
    
    public void saveToStream(final Stream stream) throws StreamException {
        final BIFF b = new BIFF();
        b.ident = 0;
        b.data().writeString("BIFF");
        b.data().writeInt(2);
        BIFF.writeBIFF(1, b, stream);
        b.reset();
        b.ident = 10;
        b.data().writeInt(this.zoom);
        BIFF.writeBIFF(2, b, stream);
        b.reset();
        b.ident = 11;
        b.data().writeInt(this.mode);
        BIFF.writeBIFF(2, b, stream);
        b.reset();
        b.ident = 12;
        b.data().writeInt(this.pageRows);
        BIFF.writeBIFF(2, b, stream);
        b.reset();
        b.ident = 13;
        b.data().writeInt(this.pageCols);
        BIFF.writeBIFF(2, b, stream);
        b.reset();
        b.ident = 14;
        b.data().writeInt(this.orientation);
        BIFF.writeBIFF(2, b, stream);
        b.reset();
        b.ident = 127;
        BIFF.writeBIFF(2, b, stream);
    }
    
    public void loadFromStream(final Stream stream) {
    }
    
    public void apply(final GridData grid) throws Exception {
        final Stream stream = (Stream)new MemStream();
        this.saveToStream(stream);
        grid.getExtDatas().setData("print.options", stream.getBytes());
    }
}
